<html>
<head>
<title>OgreShadowCameraSetupPSSM.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreShadowCameraSetupPSSM.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreShadowCameraSetupPSSM_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Copyright (c) 2006 Matthias Fink, netAllied GmbH &lt;matthias.fink@web.de&gt;                             </span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00011"></a>00011 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00012"></a>00012 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00013"></a>00013 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00014"></a>00014 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00015"></a>00015 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00016"></a>00016 <span class="comment"></span>
<a name="l00017"></a>00017 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00018"></a>00018 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00019"></a>00019 <span class="comment"></span>
<a name="l00020"></a>00020 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00021"></a>00021 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00022"></a>00022 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00023"></a>00023 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00024"></a>00024 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00025"></a>00025 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00026"></a>00026 <span class="comment">THE SOFTWARE.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __ShadowCameraSetupPSSM_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __ShadowCameraSetupPSSM_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreShadowCameraSetupLiSPSM_8h.html">OgreShadowCameraSetupLiSPSM.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037 
<a name="l00055"></a><a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html">00055</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html" title="Parallel Split Shadow Map (PSSM) shadow camera setup.">PSSMShadowCameraSetup</a> : <span class="keyword">public</span> Ogre::<a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html" title="Implements the Light Space Perspective Shadow Mapping Algorithm.">LiSPSMShadowCameraSetup</a>
<a name="l00056"></a>00056     {
<a name="l00057"></a>00057     <span class="keyword">public</span>:
<a name="l00058"></a><a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html#aad0d2ebd7081a0916ba725a109f7219a">00058</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;Real&gt;::type</a> <a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html#aad0d2ebd7081a0916ba725a109f7219a">SplitPointList</a>;
<a name="l00059"></a><a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html#a8740cd57c768f7e5f4c62265ecd6bcd2">00059</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;Real&gt;::type</a> <a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html#a8740cd57c768f7e5f4c62265ecd6bcd2">OptimalAdjustFactorList</a>;
<a name="l00060"></a>00060 
<a name="l00061"></a>00061     <span class="keyword">protected</span>:
<a name="l00062"></a><a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html#ac8dde1a383deb7b39ecc0eeb8e07fb23">00062</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html#ac8dde1a383deb7b39ecc0eeb8e07fb23">mSplitCount</a>;
<a name="l00063"></a><a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html#ae5ea0052ab8623a7dfcf09254db26c94">00063</a>         <a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html#aad0d2ebd7081a0916ba725a109f7219a">SplitPointList</a> <a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html#ae5ea0052ab8623a7dfcf09254db26c94">mSplitPoints</a>;
<a name="l00064"></a><a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html#ae31f5c1ba715780b927a0ff8ef38e1ea">00064</a>         <a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html#a8740cd57c768f7e5f4c62265ecd6bcd2">OptimalAdjustFactorList</a> <a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html#ae31f5c1ba715780b927a0ff8ef38e1ea">mOptimalAdjustFactors</a>;
<a name="l00065"></a><a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html#abb6c4f3e5a1ad73b1177794ec3f370f6">00065</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html#abb6c4f3e5a1ad73b1177794ec3f370f6">mSplitPadding</a>;
<a name="l00066"></a>00066 
<a name="l00067"></a><a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html#a56e4c81488a8984efc1c08ccd1ec86b9">00067</a>         <span class="keyword">mutable</span> <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html#a56e4c81488a8984efc1c08ccd1ec86b9">mCurrentIteration</a>;
<a name="l00068"></a>00068 
<a name="l00069"></a>00069     <span class="keyword">public</span>:
<a name="l00071"></a>00071         <a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html" title="Parallel Split Shadow Map (PSSM) shadow camera setup.">PSSMShadowCameraSetup</a>();
<a name="l00072"></a>00072         ~<a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html" title="Parallel Split Shadow Map (PSSM) shadow camera setup.">PSSMShadowCameraSetup</a>();
<a name="l00073"></a>00073 
<a name="l00080"></a>00080         <span class="keywordtype">void</span> calculateSplitPoints(<span class="keywordtype">size_t</span> splitCount, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> nearDist, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> farDist, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> lambda = 0.95);
<a name="l00081"></a>00081 
<a name="l00088"></a>00088         <span class="keywordtype">void</span> setSplitPoints(<span class="keyword">const</span> <a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html#aad0d2ebd7081a0916ba725a109f7219a">SplitPointList</a>&amp; newSplitPoints);
<a name="l00089"></a>00089 
<a name="l00093"></a>00093         <span class="keywordtype">void</span> setOptimalAdjustFactor(<span class="keywordtype">size_t</span> splitIndex, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> factor);
<a name="l00094"></a>00094 
<a name="l00098"></a><a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html#a5000b20f43bea556bcdd994550f1f0ab">00098</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html#a5000b20f43bea556bcdd994550f1f0ab" title="Set the padding factor to apply to the near &amp; far distances when matching up splits to one another...">setSplitPadding</a>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> pad) { mSplitPadding = pad; }
<a name="l00099"></a>00099 
<a name="l00103"></a><a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html#ab1cc7551a1d37c13e1b7d41dbea91442">00103</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html#ab1cc7551a1d37c13e1b7d41dbea91442" title="Get the padding factor to apply to the near &amp; far distances when matching up splits to one another...">getSplitPadding</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSplitPadding; }
<a name="l00105"></a><a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html#a8fdb600dcc6ddc16840f4181cd78428f">00105</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html#a8fdb600dcc6ddc16840f4181cd78428f" title="Get the number of splits.">getSplitCount</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSplitCount; }
<a name="l00106"></a>00106 
<a name="l00108"></a>00108         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getShadowCamera(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">Ogre::SceneManager</a> *sm, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Ogre::Camera</a> *cam,
<a name="l00109"></a>00109             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Ogre::Viewport</a> *vp, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Ogre::Light</a> *light, <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Ogre::Camera</a> *texCam, <span class="keywordtype">size_t</span> iteration) <span class="keyword">const</span>;
<a name="l00110"></a>00110 
<a name="l00112"></a><a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html#aa4752b0456b01b9e2af7021c8773d880">00112</a>         <span class="keyword">inline</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html#aad0d2ebd7081a0916ba725a109f7219a">SplitPointList</a>&amp; getSplitPoints()<span class="keyword"> const</span>
<a name="l00113"></a>00113 <span class="keyword">        </span>{ <span class="keywordflow">return</span> mSplitPoints; }
<a name="l00114"></a>00114 
<a name="l00116"></a><a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html#ab443340d115be363415a955e4004b21f">00116</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getOptimalAdjustFactor(<span class="keywordtype">size_t</span> splitIndex)<span class="keyword"> const</span>
<a name="l00117"></a>00117 <span class="keyword">        </span>{ <span class="keywordflow">return</span> mOptimalAdjustFactors[splitIndex]; }
<a name="l00118"></a>00118 
<a name="l00120"></a>00120         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getOptimalAdjustFactor() <span class="keyword">const</span>;
<a name="l00121"></a>00121 
<a name="l00122"></a>00122     };
<a name="l00125"></a>00125 }
<a name="l00126"></a>00126 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
